VERSION 5.00
Begin VB.Form frmMain 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "VBC WIC Convert"
   ClientHeight    =   975
   ClientLeft      =   45
   ClientTop       =   375
   ClientWidth     =   2865
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   65
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   191
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton Command1 
      Caption         =   "Command1"
      Height          =   675
      Left            =   90
      TabIndex        =   0
      Top             =   150
      Width           =   2625
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' Autor: F. Schler
' Datum: 07/2020

Option Explicit

Private pIWICImagingFactory As Long

Private Sub Form_Load()

    If CreateInterface(CLSID_WICImagingFactory1, IID_IWICImagingFactory, _
        pIWICImagingFactory) <> True Then
        
        Debug.Print "WICImagingFactory konnte nicht erstellt werden."
        
    End If
    
End Sub

Private Sub Form_Unload(Cancel As Integer)
    
    If pIWICImagingFactory <> 0& Then
    
        Call ReleaseInterface(pIWICImagingFactory)
    
    End If
    
End Sub

Private Sub Command1_Click()

    Dim bConvert As Boolean
    Dim sImageIn As String
    Dim sImageOut As String
    Dim tPixelFormatOut As GUID
    Dim tContainerFormatOut As GUID

    Dim pBitmap As Long
    
    bConvert = False
    sImageIn = App.Path & "\test.jpg"
    sImageOut = App.Path & "\test.png"

    tPixelFormatOut = Str2Guid(GUID_WICPixelFormat24bppBGR)
    tContainerFormatOut = Str2Guid(GUID_ContainerFormatPng)
    
    pBitmap = LoadImage(sImageIn)
    
    If pBitmap <> 0& Then
        
        pBitmap = FormatConverter(pBitmap, tPixelFormatOut)

        If pBitmap <> 0& Then

            pBitmap = BitmapScaler(pBitmap, 450, 600)

            If pBitmap <> 0& Then

                pBitmap = FlipRotator(pBitmap, WICBitmapTransformRotate180)

                If pBitmap <> 0& Then

                    If SaveImage(sImageOut, pBitmap, tContainerFormatOut) = True Then

                        Debug.Print "OK"

                    End If

                End If

            End If

        End If
    
        Call ReleaseInterface(pBitmap)

    End If

End Sub

Private Function LoadImage(ByVal sImage As String) As Long

    Dim lFrameCount As Long
    Dim lWidth As Long
    Dim lHeight As Long
    Dim lBuffSize_Tmp As Long
    Dim lBuffSize_New As Long
    Dim pRet As Long
    Dim pData_Tmp As Long
    Dim pData_New As Long
    Dim pIWICBitmap_Tmp As Long
    Dim pIWICBitmap_New As Long
    Dim pIWICBitmapLock_Tmp As Long
    Dim pIWICBitmapLock_New As Long
    Dim pIWICBitmapDecoder As Long
    Dim pIWICBitmapFrameDecode As Long
    Dim tGUID As GUID
    Dim tWICRect As WICRect
    
    If pIWICImagingFactory <> 0& Then
    
        If Invoke(pIWICImagingFactory, CreateDecoderFromFilename, StrPtr(sImage), 0&, _
            WICAccessOption.GENERIC_READ, WICDecodeOptions.WICDecodeMetadataCacheOnDemand, _
            VarPtr(pIWICBitmapDecoder)) = S_OK Then
            
            If Invoke(pIWICBitmapDecoder, GetFrameCount, VarPtr(lFrameCount)) = S_OK Then
                
                If lFrameCount > 0& Then
                
                    If Invoke(pIWICBitmapDecoder, GetFrame, 0&, VarPtr(pIWICBitmapFrameDecode)) = S_OK Then
                        
                        If Invoke(pIWICImagingFactory, CreateBitmapFromSource, pIWICBitmapFrameDecode, _
                            WICBitmapCreateCacheOption.WICBitmapCacheOnDemand, VarPtr(pIWICBitmap_Tmp)) = S_OK Then
                            
                            If Invoke(pIWICBitmap_Tmp, GetSize, VarPtr(lWidth), VarPtr(lHeight)) = S_OK Then
                            
                                If Invoke(pIWICBitmap_Tmp, GetPixelFormat, VarPtr(tGUID)) = S_OK Then
                        
                                    If Invoke(pIWICImagingFactory, CreateBitmap, lWidth, lHeight, _
                                        VarPtr(tGUID), WICBitmapCreateCacheOption.WICBitmapCacheOnDemand, _
                                        VarPtr(pIWICBitmap_New)) = S_OK Then
                                        
                                        With tWICRect
                                            .x = 0
                                            .y = 0
                                            .width = lWidth
                                            .height = lHeight
                                        End With
                                        
                                        If Invoke(pIWICBitmap_Tmp, LockBits, VarPtr(tWICRect), _
                                            WICBitmapLockFlags.WICBitmapLockRead, _
                                            VarPtr(pIWICBitmapLock_Tmp)) = S_OK Then
                                        
                                            If Invoke(pIWICBitmap_New, LockBits, VarPtr(tWICRect), _
                                                WICBitmapLockFlags.WICBitmapLockWrite, _
                                                VarPtr(pIWICBitmapLock_New)) = S_OK Then
                                            
                                                If Invoke(pIWICBitmapLock_Tmp, GetDataPointer, _
                                                    VarPtr(lBuffSize_Tmp), VarPtr(pData_Tmp)) = S_OK Then
                                                
                                                    If Invoke(pIWICBitmapLock_New, GetDataPointer, _
                                                        VarPtr(lBuffSize_New), VarPtr(pData_New)) = S_OK Then
                                                        
                                                        If lBuffSize_Tmp = lBuffSize_New Then
                                                            
                                                            If pData_Tmp <> 0& Then
                                                                
                                                                If pData_New <> 0& Then
                                                    
                                                                    Call CopyMemory(ByVal pData_New, ByVal pData_Tmp, lBuffSize_Tmp)
                        
                                                                    pRet = pIWICBitmap_New
                                                                    
                                                                End If
                                                            
                                                            End If
                                                        
                                                        End If
                                                    
                                                    End If
                                                
                                                End If
                                            
                                                Call ReleaseInterface(pIWICBitmapLock_New)
                                                
                                            End If
                                            
                                            Call ReleaseInterface(pIWICBitmapLock_Tmp)
                                        
                                        End If
                        
                                    End If
                        
                                End If
                        
                            End If
                            
                            Call ReleaseInterface(pIWICBitmap_Tmp)
                            
                        End If
                        
                        Call ReleaseInterface(pIWICBitmapFrameDecode)
                        
                    End If
                    
                End If
                
            End If
            
            Call ReleaseInterface(pIWICBitmapDecoder)
            
        End If
        
    End If
    
    LoadImage = pRet
    
End Function

Private Function SaveImage(ByVal sImage As String, ByVal pBitmap As Long, _
    ByRef tContainerFormat As GUID) As Boolean
    
    Dim bRet As Boolean
    Dim pIPropertyBag2 As Long
    Dim pIWICStream As Long
    Dim pIWICBitmapEncoder As Long
    Dim pIWICBitmapFrameEncode As Long
    
    bRet = False
    
    If pIWICImagingFactory <> 0& Then
    
        If Invoke(pIWICImagingFactory, CreateStream, _
            VarPtr(pIWICStream)) = S_OK Then
            
            If Invoke(pIWICStream, InitializeFromFilename, _
                StrPtr(sImage), WICAccessOption.GENERIC_WRITE) = S_OK Then
                
                If Invoke(pIWICImagingFactory, CreateEncoder, _
                    VarPtr(tContainerFormat), 0&, _
                    VarPtr(pIWICBitmapEncoder)) = S_OK Then
                    
                    If Invoke(pIWICBitmapEncoder, Initialize_BE, pIWICStream, _
                        WICBitmapEncoderCacheOption.WICBitmapEncoderNoCache) = S_OK Then
                        
                        If Invoke(pIWICBitmapEncoder, CreateNewFrame, _
                            VarPtr(pIWICBitmapFrameEncode), _
                            VarPtr(pIPropertyBag2)) = S_OK Then
                            
                            If Invoke(pIWICBitmapFrameEncode, Initialize_BFE, _
                                pIPropertyBag2) = S_OK Then
                                                
                                If Invoke(pIWICBitmapFrameEncode, WriteSource, _
                                    pBitmap, 0&) = S_OK Then
                                                    
                                    If Invoke(pIWICBitmapFrameEncode, Commit_BFE) = S_OK Then
                                                        
                                        bRet = True
                                                        
                                    End If
                                                    
                                End If
                                                
                            End If

                            Call ReleaseInterface(pIWICBitmapFrameEncode)
                        
                        End If
                    
                    End If
                
                    Call Invoke(pIWICBitmapEncoder, Commit_BE)

                    Call ReleaseInterface(pIWICBitmapEncoder)
                
                End If
                
            End If
                            
            Call ReleaseInterface(pIWICStream)
            
        End If
    
    End If
                      
    SaveImage = bRet
    
End Function
                    
Private Function FormatConverter(ByRef pBitmap As Long, ByRef tPixelFormatOut As GUID, _
    Optional ByVal eDitherType As WICBitmapDitherType = WICBitmapDitherTypeNone, _
    Optional ePaletteType As WICBitmapPaletteType = WICBitmapPaletteTypeMedianCut) As Long
    
    Dim pRet As Long
    Dim pIWICBitmap As Long
    Dim pIWICFormatConverter As Long
    
    If pIWICImagingFactory <> 0& Then
    
        If Invoke(pIWICImagingFactory, CreateFormatConverter, _
            VarPtr(pIWICFormatConverter)) = S_OK Then
            
            If Invoke(pIWICFormatConverter, Initialize_FC, pBitmap, _
                VarPtr(tPixelFormatOut), eDitherType, 0&, CDbl(0), _
                ePaletteType) = S_OK Then
                
                If Invoke(pIWICImagingFactory, CreateBitmapFromSource, _
                    pIWICFormatConverter, WICBitmapCreateCacheOption.WICBitmapCacheOnDemand, _
                    VarPtr(pIWICBitmap)) = S_OK Then
                    
                    Call ReleaseInterface(pBitmap)

                    pRet = pIWICBitmap
                            
               End If
                
            End If
        
            Call ReleaseInterface(pIWICFormatConverter)

        End If
    
    End If
        
    FormatConverter = pRet
    
End Function

Private Function BitmapScaler(ByRef pBitmap As Long, ByVal lWidth As Long, _
    ByVal lHeight As Long, Optional ByVal eInterpolationMode As _
    WICBitmapInterpolationMode = WICBitmapInterpolationModeFant) As Long
    
    Dim pRet As Long
    Dim pIWICBitmap As Long
    Dim pIWICBitmapScaler As Long
    
    If pIWICImagingFactory <> 0& Then
    
        If Invoke(pIWICImagingFactory, CreateBitmapScaler, _
            VarPtr(pIWICBitmapScaler)) = S_OK Then
            
            If Invoke(pIWICBitmapScaler, Initialize_BS, pBitmap, lWidth, _
                lHeight, eInterpolationMode) = S_OK Then
            
                If Invoke(pIWICImagingFactory, CreateBitmapFromSource, _
                    pIWICBitmapScaler, WICBitmapCreateCacheOption.WICBitmapCacheOnDemand, _
                    VarPtr(pIWICBitmap)) = S_OK Then
                    
                    Call ReleaseInterface(pBitmap)

                    pRet = pIWICBitmap
                            
               End If
            
            End If
    
            Call ReleaseInterface(pIWICBitmapScaler)
            
        End If
    
    End If

    BitmapScaler = pRet

End Function

Private Function FlipRotator(ByRef pBitmap As Long, Optional ByVal eTransformOptions _
    As WICBitmapTransformOptions = WICBitmapTransformRotate0) As Long

    Dim pRet As Long
    Dim pIWICBitmap As Long
    Dim pIWICBitmapFlipRotator As Long

    If pIWICImagingFactory <> 0& Then

        If Invoke(pIWICImagingFactory, CreateBitmapFlipRotator, _
            VarPtr(pIWICBitmapFlipRotator)) = S_OK Then
            
            If Invoke(pIWICBitmapFlipRotator, Initialize_BFR, pBitmap, _
                eTransformOptions) = S_OK Then
            
                If Invoke(pIWICImagingFactory, CreateBitmapFromSource, _
                    pIWICBitmapFlipRotator, _
                    WICBitmapCreateCacheOption.WICBitmapCacheOnDemand, _
                    VarPtr(pIWICBitmap)) = S_OK Then
                    
                    Call ReleaseInterface(pBitmap)

                    pRet = pIWICBitmap
                            
               End If
            
            End If
            
            Call ReleaseInterface(pIWICBitmapFlipRotator)
        
        End If

    End If
    
    FlipRotator = pRet
    
End Function
